#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"


int 
main(int argc, char **argv)
{
  int j, p, tag;
  int *v;
  int *xs;
  int n;
  int i,d;
  double start,end;


  /* Start up MPI */

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &j);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
 

  sscanf(argv[1],"%d",&n);

  if (j == 0) 
   {
    xs = (int *) malloc(n*sizeof(int));
    for (i=0;i<n;++i) scanf("%d",xs+i);
   }

  int nop = n/p;
  // printf ("%d:%d:%d\n",n,p,nop);
  v = (int *) malloc(nop*sizeof(int));
  MPI_Scatter(xs,nop,MPI_INT,v,nop,MPI_INT,0,MPI_COMM_WORLD);

  MPI_Win win;
  MPI_Aint sizeOfInt;

  MPI_Type_extent(MPI_INT,&sizeOfInt);

  int r;
  MPI_Win_create(&r,sizeOfInt,1,MPI_INFO_NULL,MPI_COMM_WORLD,&win);
  MPI_Win_fence(0,win); 

  printf("%d: win created. will put to %d\n",j,(j+1)%p);


  start = MPI_Wtime();

  int z = 0;
  for (i=0;i<nop;++i) z+=v[i];
  r = z;
  MPI_Barrier(MPI_COMM_WORLD);

  if (0 != j)
   {
    MPI_Accumulate(&z,1,MPI_INT,
		    0,0,1,MPI_INT,MPI_SUM,win);
   }

   
  MPI_Win_fence(0,win);
  end = MPI_Wtime();

 
  printf("%d: r is %d \n",j,r);
  MPI_Finalize();
  return 0;
}
