#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"


int 
main(int argc, char **argv)
{
  int j, p, tag;
  int z;
  int *v;
  int *xs;
  int n;
  int nv;
  int i,d;
  double start,end;


  /* Start up MPI */

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &j);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
 

  /* Arbitrarily choose 201 to be our tag.  Calculate the */
  /* rank of the to process in the ring.  Use the modulus */
  /* operator so that the last process "wraps around" to rank */
  /* zero. */

  tag = 201;

  sscanf(argv[1],"%d",&n);

  if (j == 0) 
   {
    xs = (int *) malloc(n*sizeof(int));
    for (i=0;i<n;++i) scanf("%d",xs+i);
   }

  nv = n/p;
  // printf ("%d:%d:%d\n",n,p,nv);
  v = (int *) malloc(nv*sizeof(int));
  MPI_Scatter(xs,nv,MPI_INT,v,nv,MPI_INT,0,MPI_COMM_WORLD);

  start = MPI_Wtime();

  z = 0;
  for (i=0;i<nv;++i) z+=v[i];

  for (d=1;d<p;d*=2)
   {
    int to = j-d;
    int from = j+d;
    int sz = 2*d;
    int r;

    MPI_Request req;

    MPI_Status status;
    
    //printf("d %d:to %d:from %d\n",d,to,from);
    //scanf("%d",&r);
    if (to>=0 && (to%sz) == 0)
     {
      MPI_Isend(&z, 1, MPI_INT, to, tag, MPI_COMM_WORLD,&req);
     }
    
    if (from < n && j%sz == 0)
     {
      MPI_Recv(&r, 1, MPI_INT, from, tag, MPI_COMM_WORLD, &status);
     }

    if (to>=0 && (to%sz) == 0)
     {
      MPI_Wait(&req,&status);
     }
    z += r;
   }
  end = MPI_Wtime();

 
  if (0 == j)
   {
    printf("sum is %d in %fs\n",z,end-start);
   }
  MPI_Finalize();
  return 0;
}
